"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FrontMatterComponent = void 0;
const typedoc_1 = require("typedoc");
const front_matter_1 = require("typedoc-plugin-markdown/dist/utils/front-matter");
const components_1 = require("typedoc/dist/lib/converter/components");
const components_2 = require("typedoc/dist/lib/output/components");
const events_1 = require("typedoc/dist/lib/output/events");
let FrontMatterComponent = class FrontMatterComponent extends components_2.RendererComponent {
    initialize() {
        super.initialize();
        this.listenTo(this.application.renderer, {
            [events_1.PageEvent.END]: this.onPageEnd,
        });
    }
    onPageEnd(page) {
        if (page.contents) {
            const items = {
                title: this.getTitle(page),
            };
            page.contents = front_matter_1.prependYAML(page.contents, items);
        }
    }
    getTitle(page) {
        if (page.url === this.entryDocument && page.url !== page.project.url) {
            return page.project.name;
        }
        return front_matter_1.getPageTitle(page);
    }
};
__decorate([
    typedoc_1.BindOption('entryDocument')
], FrontMatterComponent.prototype, "entryDocument", void 0);
__decorate([
    typedoc_1.BindOption('entryPoints')
], FrontMatterComponent.prototype, "entryPoints", void 0);
FrontMatterComponent = __decorate([
    components_1.Component({ name: 'front-matter' })
], FrontMatterComponent);
exports.FrontMatterComponent = FrontMatterComponent;
