"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.render = void 0;
const fs = __importStar(require("fs"));
const progress_1 = __importDefault(require("progress"));
const events_1 = require("typedoc/dist/lib/output/events");
async function render(project, outputDirectory) {
    if (!this.prepareTheme() ||
        !isOutputDirectory(this.application, outputDirectory)) {
        return;
    }
    const output = new events_1.RendererEvent(events_1.RendererEvent.BEGIN, outputDirectory, project);
    output.settings = this.application.options.getRawValues();
    output.urls = this.theme.getUrls(project);
    if (output.urls) {
        const bar = new progress_1.default('Rendering [:bar] :percent', {
            total: output.urls.length,
            width: 40,
        });
        this.trigger(output);
        if (!output.isDefaultPrevented) {
            output.urls.forEach((mapping, i) => {
                this.renderDocument(output.createPageEvent(mapping));
                bar.tick();
            });
            this.trigger(events_1.RendererEvent.END, output);
        }
    }
}
exports.render = render;
const isOutputDirectory = (app, outputDirectory) => {
    const options = app.options.getRawValues();
    if (options.disableOutputCheck) {
        return true;
    }
    if (!fs.existsSync(outputDirectory)) {
        return true;
    }
    if (app.renderer.theme.isOutputDirectory(outputDirectory)) {
        if (fs.existsSync(outputDirectory)) {
            fs.rmdirSync(outputDirectory, { recursive: true });
        }
        return true;
    }
    else {
        app.logger.error(`The output directory "${outputDirectory}" exists but does not seem to be a documentation generated by TypeDoc.\n` +
            'Make sure this is the right target directory, delete the folder and rerun TypeDoc.');
        return false;
    }
};
